Module javafx.base
Package javafx.beans.binding

# Class StringBinding

java.lang.Object
javafx.beans.binding.StringExpression
javafx.beans.binding.StringBinding

All Implemented Interfaces:
  `Binding<String>`, `Observable`, `ObservableObjectValue<String>`, `ObservableStringValue`, `ObservableValue<String>`

    public abstract class StringBinding
    extends StringExpression
    implements Binding<String>

Base class that provides most of the functionality needed to implement a `Binding` of a `String`.

`StringBinding` provides a simple invalidation-scheme. An extending class can register dependencies by calling `bind(Observable...)`. If One of the registered dependencies becomes invalid, this `StringBinding` is marked as invalid. With `unbind(Observable...)` listening to dependencies can be stopped.

To provide a concrete implementation of this class, the method `computeValue()` has to be implemented to calculate the value of this binding based on the current state of the dependencies. It is called when `get()` is called for an invalid binding.

See `DoubleBinding` for an example how this base class can be extended.

Since:
  JavaFX 2.0
See Also:
  `Binding`, `StringExpression`

- ## Constructor Summary

  Constructors
  Constructor | Description
  --- | ---
  `StringBinding()` | Creates a default `StringBinding`.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `protected void` | `bind​(Observable... dependencies)` | Start observing the dependencies for changes.
  `protected abstract String` | `computeValue()` | Calculates the current value of this binding.
  `void` | `dispose()` | A default implementation of `dispose()` that is empty.
  `String` | `get()` | Returns the result of `computeValue()`.
  `ObservableList<?>` | `getDependencies()` | A default implementation of `getDependencies()` that returns an empty `ObservableList`.
  `protected void` | `onInvalidating()` | The method onInvalidating() can be overridden by extending classes to react, if this binding becomes invalid.
  `String` | `toString()` | Returns a string representation of this `StringBinding` object.
  `protected void` | `unbind​(Observable... dependencies)` | Stop observing the dependencies for changes.

  ### Methods declared in class javafx.beans.binding.StringExpression

  `concat, getValueSafe, greaterThan, greaterThan, greaterThanOrEqualTo, greaterThanOrEqualTo, isEmpty, isEqualTo, isEqualTo, isEqualToIgnoreCase, isEqualToIgnoreCase, isNotEmpty, isNotEqualTo, isNotEqualTo, isNotEqualToIgnoreCase, isNotEqualToIgnoreCase, isNotNull, isNull, length, lessThan, lessThan, lessThanOrEqualTo, lessThanOrEqualTo, stringExpression`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods declared in interface javafx.beans.binding.Binding

  `invalidate, isValid`

  ### Methods declared in interface javafx.beans.Observable

  `addListener, removeListener`

  ### Methods declared in interface javafx.beans.value.ObservableValue

  `addListener, getValue, removeListener`

- ## Constructor Details

  - ### StringBinding

    public StringBinding()
    Creates a default `StringBinding`.

- ## Method Details

  - ### bind

    protected final void bind​(Observable... dependencies)
    Start observing the dependencies for changes. If the value of one of the dependencies changes, the binding is marked as invalid.
    Parameters:
      `dependencies` - the dependencies to observe

  - ### unbind

    protected final void unbind​(Observable... dependencies)
    Stop observing the dependencies for changes.
    Parameters:
      `dependencies` - the dependencies to stop observing

  - ### dispose

    public void dispose()
    A default implementation of `dispose()` that is empty.
    Specified by:
      `dispose` in interface `Binding<String>`

  - ### getDependencies

    public ObservableList<?> getDependencies()
    A default implementation of `getDependencies()` that returns an empty `ObservableList`.
    Specified by:
      `getDependencies` in interface `Binding<String>`
    Returns:
      an empty `ObservableList`

  - ### get

    public final String get()
    Returns the result of `computeValue()`. The method `computeValue()` is only called if the binding is invalid. The result is cached and returned if the binding did not become invalid since the last call of `get()`.
    Specified by:
      `get` in interface `ObservableObjectValue<String>`
    Returns:
      the current value

  - ### onInvalidating

    protected void onInvalidating()
    The method onInvalidating() can be overridden by extending classes to react, if this binding becomes invalid. The default implementation is empty.

  - ### computeValue

    protected abstract String computeValue()
    Calculates the current value of this binding.

    Classes extending `StringBinding` have to provide an implementation of `computeValue`.

    Returns:
      the current value

  - ### toString

    public String toString()
    Returns a string representation of this `StringBinding` object.
    Overrides:
      `toString` in class `Object`
    Returns:
      a string representation of this `StringBinding` object.